/*
 * jQuery Draggable Object 1.1
 *
 * NO COPYRIGHTS OR LICENSES. DO WHAT YOU LIKE.
 *
 * http://digipiph.com
 *
 * File generated: Mon Mar 2 11:10 EST 2015
 */
(function($){

  //START $.fn.draggableObject
  $.fn.draggableObject = function (instanceSettings) {

    //settings
    var defaultSettings = {
      zindex:   9999,
      fixedPos: true
    };



    /***********************
    //General Configuring (Function Variables)
    ***********************/

    // get the defaults or any user set options
    var settings = $.extend(defaultSettings, instanceSettings);

    //function variables
    var currentObject = $(this);
    var copyObj = $(this).clone();
    var mouse_x;
    var mouse_y;
    var div_x;
    var div_y;
    var initialPos_x;
    var initialPos_y;
    var newPos_x;
    var newPos_y;
    var beingDragged = false;

    /***********************
    //Setup the draggableObject
    ***********************/
    $(copyObj).prependTo(document.body);

    if (settings.fixedPos) {
      $(copyObj).css('position', 'fixed');
    }
    else {
      $(copyObj).css('position', 'absolute');
    }

    $(copyObj).css({
      'z-index'  : settings.zindex,
      'margin'   : '0px',
      'left'     : $(currentObject).offset().left +'px',
      'top'      : $(currentObject).offset().top +'px'
    });

    //remove the original object
    $(currentObject).remove();

    /***********************
    //draggableObject Functionality
    ***********************/

    //detect if the mouse is moving within the window
    $(document).mousemove(function(e) {

      //if our element is being dragged, figure the new position
      if (beingDragged) {

        mouse_x = e.clientX;
        mouse_y = e.clientY;
        div_x = $(copyObj).offset().left;
        div_y = $(copyObj).offset().top;

        if (!initialPos_x) initialPos_x = mouse_x - div_x;
        if (!initialPos_y) initialPos_y = mouse_y - div_y;
        newPos_x = mouse_x - initialPos_x;
        newPos_y = mouse_y - initialPos_y;
        $(copyObj).css('left', newPos_x+'px');
        $(copyObj).css('top', newPos_y+'px');
      }

    });

    //Mousedown on our object, enable dragging
    $(copyObj).mousedown(function(){
      beingDragged = true;
      $(copyObj).css({
        'position' : 'absolute',
        'cursor'   : 'move',
        'left'     : $(copyObj).offset().left +'px',
        'top'      : $(copyObj).offset().top +'px'
      });
      $('body').css({
        '-webkit-user-select' : 'none',
        '-khtml-user-select'  : 'none',
        '-moz-user-select'    : 'none',
        '-o-user-select'      : 'none',
        'user-select'         : 'none'
      });
    });

    //Mouseup on our object, lock dragging and set a fixed positioning if enabled
    $(copyObj).mouseup(function(){
      initialPos_x = false;
      initialPos_y = false;
      beingDragged = false;

      if (settings.fixedPos) {
        $(copyObj).css({
        'position' : 'fixed',
        'cursor'   : 'auto',
        'left'     : newPos_x - $(document).scrollLeft() +'px',
        'top'      : newPos_y - $(document).scrollTop() +'px'
      });
      } else {
        $(copyObj).css({
          'position' : 'absolute',
          'cursor'   : 'auto'
        });
      }

      $('body').css({
        '-webkit-user-select' : 'auto',
        '-khtml-user-select'  : 'auto',
        '-moz-user-select'    : 'auto',
        '-o-user-select'      : 'auto',
        'user-select'         : 'auto'
      });

    });

    //If the user gets wacky and moves the mouse too fast, lets make sure our div object stays under the mouse
    $(copyObj).mouseleave(function(){
      if (beingDragged) {
        if (settings.fixedPos) {

          var leftPos = newPos_x - $(document).scrollLeft();
          var rightPos = newPos_y - $(document).scrollTop();

          $(copyObj).css({
            'left'     :  leftPos+'px',
            'top'      :  rightPos+'px'
          });
        } 
        else {
          $(copyObj).css({
            'left'     : newPos_x+'px',
            'top'      : newPos_y+'px'
          });
        }
      }
    });

  }
  //END $.fn.draggableObject

})(jQuery)